// ServiceTest.cpp : Defines the entry point for the console application.
// ..
#include "stdafx.h"
#include <stdio.h>
#include <ws2tcpip.h>
#include <winsock2.h>
#include <iphlpapi.h>
#include <wtsapi32.h>
#include <lm.h>

#pragma comment(lib, "wtsapi32.lib")
#pragma comment(lib, "ws2_32.lib")
#pragma comment(lib, "iphlpapi.lib")
#pragma comment(lib, "netapi32.lib")
#pragma comment(lib, "advapi32.lib")

#define SERVICENAME "Netams4_Service"
#define LOGFILE "C:\\Netams4_Service_log.txt"	//Temporary log
#define DEFAULT_BUFLEN 512	//Max size of recieved string

typedef enum {
	EVENT_NOACTION = 0,
	EVENT_LOGON = 1,
	EVENT_LOGOFF = 2,
	EVENT_SHUTDOWN = 3
} Event_Type;

char *Server_Name;
DWORD Interval;
char *Password;
char *Port_Num;
bool HTTP_Used;
char* URL_Part;
char User_Name_String[256];
Event_Type Last_Action;
SERVICE_STATUS ServiceStatus; 
SERVICE_STATUS_HANDLE hStatus;

int WriteToLog(char* str)
{
   FILE* log;
   log = fopen(LOGFILE, "a+");
   if (log == NULL) return -1;
   fprintf(log, "%s\n", str);
   fclose(log);
   return 0;
}

void Report(char *Username_String, Event_Type What_Happened, char *Pwd)
{
	//Get computer name
	TCHAR Name_Buf[128];
	char Comp_Name_String[256];
	DWORD Name_Len_Count;
	GetComputerName(Name_Buf, &Name_Len_Count);
	wcstombs(Comp_Name_String, Name_Buf, 256);
	
	//Get the Windows domain name
	char Win_Domain_Name_String[256];
	LPWKSTA_INFO_100 Ws_Info_Buf = NULL;
	NetWkstaGetInfo(NULL, 100, (LPBYTE *) &Ws_Info_Buf);
	sprintf(Win_Domain_Name_String, "%S", Ws_Info_Buf->wki100_langroup);

	//Open connection to server
	addrinfo *result = NULL, hints;
	SOCKET ConnectSocket = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP);
	if (ConnectSocket == INVALID_SOCKET) return;
	ZeroMemory(&hints, sizeof(hints));
    hints.ai_family = AF_INET;
    hints.ai_socktype = SOCK_STREAM;
    hints.ai_protocol = IPPROTO_TCP;
	
	//If auth server unknown...
	if (Server_Name == NULL || getaddrinfo(Server_Name, Port_Num, &hints, &result) != 0)
	{
		//...get local domain name...
		char Domain_Name_String[256];
		TCHAR Name_Buf_Ex[128];
		DWORD Name_Len_Count_Ex;
		GetComputerNameEx(ComputerNameDnsDomain, Name_Buf_Ex, &Name_Len_Count_Ex);
		wcstombs(Domain_Name_String, Name_Buf_Ex, 256);

		//...and try to resolve netams4-auth.localdomain address
		char Tmp_Addr[256] = "\0";
		sprintf(Tmp_Addr, "netams4-auth.%s", Domain_Name_String);
		if (getaddrinfo(Tmp_Addr, Port_Num, &hints, &result) != 0)
		{
			//If this failed, use default gateway address
			IP_ADAPTER_INFO AdapterInfo_G[32];
			DWORD dwBufLen_G = sizeof(AdapterInfo_G);
			GetAdaptersInfo(AdapterInfo_G, &dwBufLen_G);
			getaddrinfo(AdapterInfo_G[0].GatewayList.IpAddress.String, Port_Num, &hints, &result);
		}
	}
	if (connect(ConnectSocket, result->ai_addr, (int)result->ai_addrlen) == SOCKET_ERROR) {
		closesocket(ConnectSocket);
		return;
	}

	//Get IP address
	sockaddr_in stLclAddr;
	int addrLen = sizeof(sockaddr_in);
	getsockname(ConnectSocket, (sockaddr FAR *) &stLclAddr, &addrLen);
	char IP_Addr_String[MAX_PATH] = "\0";
	char Tmp_IP[MAX_PATH] = "\0";
	sprintf(IP_Addr_String, "%s", inet_ntoa(stLclAddr.sin_addr));
	
	//Get MAC address
	IP_ADAPTER_INFO AdapterInfo[32];
	DWORD dwBufLen = sizeof(AdapterInfo);
	GetAdaptersInfo(AdapterInfo, &dwBufLen);
    PIP_ADAPTER_INFO pAdapterInfo = AdapterInfo;
    char MAC_Addr_String[MAX_PATH] = "\0";

	//Scan all present adapters...
	bool Just_Started = true;	//If no adapter corresponds to IP (localhost connection) return the address of the first listed adapter
    while(pAdapterInfo)
    {	
		PIP_ADDR_STRING CurIP = &(pAdapterInfo->IpAddressList);
		while(CurIP)
		{
			//...and find the corresponding IP address
			if(Just_Started || strcmp(CurIP->IpAddress.String, IP_Addr_String) == 0)
			{
				sprintf(MAC_Addr_String, "%.2x-%.2x-%.2x-%.2x-%.2x-%.2x",
					pAdapterInfo->Address[0],
					pAdapterInfo->Address[1],
					pAdapterInfo->Address[2],
					pAdapterInfo->Address[3],
					pAdapterInfo->Address[4],
					pAdapterInfo->Address[5]);
				Just_Started = false;
			}
			CurIP = CurIP->Next;
		}
		pAdapterInfo = pAdapterInfo->Next;
    }
	
	//Form the report string and send it to server
	char *What_Happened_String;
	switch (What_Happened)
	{
	case EVENT_LOGON:
		What_Happened_String = "logon";
		break;
	case EVENT_LOGOFF:
		What_Happened_String = "logoff";
		break;
	case EVENT_SHUTDOWN:
		What_Happened_String = "shutdown";
		break;
	default:	//No action, this must not happen
		What_Happened_String = "\0";
	}
	char Report_String[512] = "\0";
	if (!HTTP_Used)
		sprintf(Report_String, "Username = %s; Action = %s; IP Addr = %s; MAC Addr = %s; Computer name = %s; Domain name = %s; Password = %s",
			Username_String, What_Happened_String, IP_Addr_String, MAC_Addr_String, Comp_Name_String, Win_Domain_Name_String, Pwd);
	else
		sprintf(Report_String, "GET %s?username=%s&action=%s&ip=%s&MAC_Addr=%s&Computer_name=%s&Domain_name=%s&Password=%s&service-based=true HTTP/1.0\n\n",
			URL_Part, Username_String, What_Happened_String, IP_Addr_String, MAC_Addr_String, Comp_Name_String, Win_Domain_Name_String, Pwd);
	if(send(ConnectSocket, Report_String, (int) strlen(Report_String), 0) == SOCKET_ERROR)
	{
		closesocket(ConnectSocket);
		return;
	}

	//Receive the reply from server
	shutdown(ConnectSocket, SD_SEND);
	char Recv_Buffer[DEFAULT_BUFLEN];
	int Recv_Buf_Len = DEFAULT_BUFLEN; 
	recv(ConnectSocket, Recv_Buffer, Recv_Buf_Len, 0);
	closesocket(ConnectSocket);

	//Write to log
	WriteToLog("Sent:");
	WriteToLog(Report_String);
	WriteToLog("Recieved:");
	WriteToLog(Recv_Buffer);
	return;
}

void ControlHandler(DWORD request, DWORD EventType, WTSSESSION_NOTIFICATION *SessionData) 
{ 
	DWORD SessID;
	LPWSTR userName;
	DWORD userName_Len;
	//Last_Action = EVENT_NOACTION;

	switch(request) 
	{ 
	case SERVICE_CONTROL_STOP: 
		ServiceStatus.dwWin32ExitCode = 0; 
		ServiceStatus.dwCurrentState = SERVICE_STOPPED; 
		SetServiceStatus (hStatus, &ServiceStatus);

		//Perform cleanup
		WSACleanup();
		break; 
 
	case SERVICE_CONTROL_SHUTDOWN: 
		ServiceStatus.dwWin32ExitCode = 0; 
		ServiceStatus.dwCurrentState = SERVICE_STOPPED; 
		SetServiceStatus (hStatus, &ServiceStatus);

		//Get user name, this sends the name of the 1st logged on user
		PWTS_SESSION_INFO SessInfo[16];
		DWORD Sess_Count;
		WTSEnumerateSessions(WTS_CURRENT_SERVER_HANDLE, 0, 1, SessInfo, &Sess_Count);
		SessID = SessInfo[0]->SessionId;
		userName_Len = 0;
		WTSQuerySessionInformation(WTS_CURRENT_SERVER_HANDLE, SessID, WTSUserName, &userName, &userName_Len);
		if (wcslen(userName) > 0) wcstombs(User_Name_String, userName, 256);
		Last_Action = EVENT_SHUTDOWN;

		//Report to server
		Report(User_Name_String, Last_Action, Password);

		//Perform cleanup
		WSACleanup();
		break;

	case SERVICE_CONTROL_SESSIONCHANGE:

		//Get user name
		SessID = SessionData -> dwSessionId;
		userName_Len = 0;
		WTSQuerySessionInformation(WTS_CURRENT_SERVER_HANDLE, SessID, WTSUserName, &userName, &userName_Len);
		if (wcslen(userName) > 0) wcstombs(User_Name_String, userName, 256);

		//Report on the specific event
		switch(EventType)
		{
		case WTS_SESSION_LOGON:
			Last_Action = EVENT_LOGON;
			Report(User_Name_String, Last_Action, Password);
			break;
		case WTS_SESSION_LOGOFF:
			Last_Action = EVENT_LOGOFF;
			Report(User_Name_String, Last_Action, Password);
			break;
		}

		break;
	} 
 
	return; 
}

void WINAPI ServiceMain(int argc, char** argv){

	//Register control handler
	hStatus = RegisterServiceCtrlHandlerEx(TEXT(SERVICENAME), (LPHANDLER_FUNCTION_EX)ControlHandler, NULL); 
	if (hStatus == (SERVICE_STATUS_HANDLE)0) return;

	//Init WinSock
	WSAData wsaData;
	WSAStartup(MAKEWORD(1, 1), &wsaData);

	//Add session change control here
	ServiceStatus.dwServiceType = SERVICE_WIN32_OWN_PROCESS | SERVICE_INTERACTIVE_PROCESS;	//Needed for tray icon
	ServiceStatus.dwWin32ExitCode = 0; 
	ServiceStatus.dwServiceSpecificExitCode = 0; 
	ServiceStatus.dwCheckPoint = 0; 
	ServiceStatus.dwWaitHint = 0;
	ServiceStatus.dwCurrentState = SERVICE_RUNNING; 
	ServiceStatus.dwControlsAccepted = SERVICE_ACCEPT_STOP | SERVICE_ACCEPT_SHUTDOWN | SERVICE_ACCEPT_SESSIONCHANGE;
	SetServiceStatus(hStatus, &ServiceStatus);

	//Prevent reporting before first session change
	Last_Action = EVENT_NOACTION;

	//Droching cycle
	while (ServiceStatus.dwCurrentState == SERVICE_RUNNING)
	{
		if (User_Name_String && Last_Action != EVENT_NOACTION && Interval)
			Report(User_Name_String, Last_Action, Password);
		Sleep(Interval);
	}
	return; 
}

int main(int argc, char** argv)
{
	//Parse service parameters
	Server_Name = NULL;
	Interval = 0;
	Password = NULL;
	Port_Num = NULL;
	URL_Part = NULL;
	char *Tmp_Server_Name = NULL;
	for (int Ctr = 1; Ctr < argc; Ctr ++)
	{
		switch(argv[Ctr][0])
		{
		case 's':
			Tmp_Server_Name = argv[Ctr]+2;
			break;
		case 'i':
			Interval = atoi(argv[Ctr]+2)*1000;
			break;
		case 'p':
			Port_Num = argv[Ctr]+2;
			break;
		case 'a':
			Password = argv[Ctr]+2;
			break;
		default:
			break;
		}
	}
	HTTP_Used = Tmp_Server_Name && (!strncmp(Tmp_Server_Name, "http://", 7) || !strncmp(Tmp_Server_Name, "HTTP://", 7));

	//Parse server URL
	if (HTTP_Used)
	{
		//Extract host name
		Tmp_Server_Name += 7;
		char *Pos_1 = strchr(Tmp_Server_Name, ':');
		int Host_Len = Pos_1 - Tmp_Server_Name;
		Server_Name = new char[Host_Len + 1];
		strncpy(Server_Name, Tmp_Server_Name, Host_Len);
		Server_Name[Host_Len] = '\0';
		
		//Extract port number
		Tmp_Server_Name += Host_Len + 1;
		URL_Part = strchr(Tmp_Server_Name, '/');
		Port_Num = new char[URL_Part-Pos_1+1];
		int Port_Len = URL_Part - Tmp_Server_Name;
		Port_Num = new char[Port_Len + 1];
		strncpy(Port_Num, Tmp_Server_Name, Port_Len);
		Port_Num[Port_Len] = '\0';
	}
	else
		Server_Name = Tmp_Server_Name;
	if(!Password || !Port_Num) return -1; //Password and port number are required
	
	SERVICE_TABLE_ENTRY ServiceTable[2];
	ServiceTable[0].lpServiceName = TEXT(SERVICENAME);
	ServiceTable[0].lpServiceProc = (LPSERVICE_MAIN_FUNCTION)ServiceMain;
	ServiceTable[1].lpServiceName = NULL;
	ServiceTable[1].lpServiceProc = NULL;
	StartServiceCtrlDispatcher(ServiceTable);
	return 0;
}
